level-1 6.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198
  1. #!/bin/sh
  2. #
  3. # Run this script as root on the machine that has the tape drive, to make a
  4. # level-1 dump containing all files changed since the last full dump.
  5. #
  6. # If you give `now' as an argument, the dump is done immediately.
  7. # Otherwise, it waits until 1am.
  8. #
  9. # You must edit the file `backup-specs' to set the parameters for your site.
  10. # Useful for backup-specs, in case things have to be done slightly
  11. # differently for different dump levels.
  12. DUMP_LEVEL=1
  13. # Insure `mail' is in PATH.
  14. PATH="/usr/ucb:${PATH}"
  15. export PATH
  16. # This is not the most reliable test in the world. The following might be
  17. # more predictable:
  18. #
  19. # whoami="`whoami`"
  20. # euid="`sed -ne '/^'\"${whoami}\"':/{s/^[^:]*:[^:]*://;s/:.*//p;q;}' /etc/passwd`"
  21. # if [ "${euid}" != 0 ]; then ...
  22. #
  23. if [ ! -w / ]; then
  24. echo "The backup must be run as root or else some files will fail to be dumped."
  25. exit 1
  26. fi
  27. # Get the values of BACKUP_DIRS, BACKUP_FILES, and other variables.
  28. . ./backup-specs
  29. # Maybe sleep until around specified or default hour.
  30. if [ "z${1}" != "znow" ]; then
  31. if [ "${1}x" != "x" ]; then
  32. spec="${1}"
  33. else
  34. spec="${BACKUP_HOUR}"
  35. fi
  36. pausetime="`date | awk '
  37. {
  38. hr = substr($4, 1, 2);
  39. mn = substr($4, 4, 2);
  40. if((hr + 0) < (spec + 0))
  41. print 3600 * (spec - hr) - 60 * mn;
  42. else
  43. print 3600 * (spec + (24 - hr)) - 60 * mn;
  44. }' spec=\"${spec}\"`"
  45. clear
  46. echo "${SLEEP_MESSAGE}"
  47. sleep "${pausetime}"
  48. fi
  49. # start doing things
  50. # Put startdate in the subject line of mailed report, since if it happens
  51. # to run longer than 24 hours (as may be the case if someone forgets to put
  52. # in the next volume of the tape in adequate time), the backup date won't
  53. # appear too misleading.
  54. startdate="`date`"
  55. here="`pwd`"
  56. # Logfile name should be in the form ``log-1993-03-18-level-1''
  57. # i.e. year-month-date. This format is useful for sorting by name, since
  58. # logfiles are intentionally kept online for future reference.
  59. LOGFILE=log-`date | awk '
  60. BEGIN {
  61. d["Jan"] = "01"; d["Feb"] = "02"; d["Mar"] = "03";
  62. d["Apr"] = "04"; d["May"] = "05"; d["Jun"] = "06";
  63. d["Jul"] = "07"; d["Aug"] = "08"; d["Sep"] = "09";
  64. d["Oct"] = "10"; d["Nov"] = "11"; d["Dec"] = "12";
  65. }
  66. {
  67. if ($3 < 10) $3 = "0" $3;
  68. print $6 "-" d[$2] "-" $3;
  69. }'`-level-${DUMP_LEVEL}
  70. localhost="`hostname | sed -e 's/\..*//'`"
  71. TAR_PART1="/usr/local/bin/tar -c --multi-volume --one-file-system --block=${BLOCKING} --sparse --volno-file=${VOLNO_FILE}"
  72. # Only use --info-script if DUMP_REMIND_SCRIPT was defined in backup-specs
  73. if [ "x${DUMP_REMIND_SCRIPT}" != "x" ]; then
  74. TAR_PART1="${TAR_PART1} --info-script='${DUMP_REMIND_SCRIPT}'"
  75. fi
  76. # Make sure the log file did not already exist. Create it.
  77. if [ -f "${LOGFILE}" ] ; then
  78. echo "Log file ${LOGFILE} already exists." 1>&2
  79. exit 1
  80. else
  81. touch "${LOGFILE}"
  82. fi
  83. # Most everything below here is run in a subshell for which all output is
  84. # piped through `tee' to the logfile. Doing this, instead of having
  85. # multiple pipelines all over the place, is cleaner and allows access to
  86. # the exit value from various commands more easily.
  87. (
  88. # Caveat: Some version of `mt' require `-t', not `-f'.
  89. mt -f "${TAPE_FILE}" rewind
  90. rm -f "${VOLNO_FILE}"
  91. set - "${BACKUP_DIRS}"
  92. while [ $# -ne 0 ] ; do
  93. date="`date`"
  94. remotehost="`echo \"${1}\" | sed -e 's/:.*$//'`"
  95. fs="`echo \"${1}\" | sed -e 's/^.*://'`"
  96. fsname="`echo \"${1}\" | sed -e 's/\//:/g'`"
  97. # This filename must be absolute; it is opened on the machine that runs tar.
  98. TAR_PART2="--listed=/etc/tar-backup/temp.level-1"
  99. TAR_PART3="--label='level 1 backup of ${fs} on ${remotehost} at ${date}' -C ${fs} ."
  100. echo "Backing up ${1} at ${date}"
  101. echo "Last full dump on this filesystem:"
  102. if [ "z${remotehost}" != "z${localhost}" ] ; then
  103. rsh "${remotehost}" "ls -l /etc/tar-backup/${fsname}.level-0; \
  104. cp /etc/tar-backup/${fsname}.level-0 /etc/tar-backup/temp.level-1"
  105. else
  106. ls -l "/etc/tar-backup/${fsname}.level-0"
  107. cp "/etc/tar-backup/${fsname}.level-0" /etc/tar-backup/temp.level-1
  108. fi
  109. # Actually back things up.
  110. if [ "z${remotehost}" != "z${localhost}" ] ; then
  111. rsh "${remotehost}" ${TAR_PART1} -f "${localhost}:${TAPE_FILE}" ${TAR_PART2} ${TAR_PART3}
  112. else
  113. # Using `sh -c exec' causes nested quoting and shell substitution
  114. # to be handled here in the same way rsh handles it.
  115. sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3}"
  116. fi
  117. # `rsh' doesn't exit with the exit status of the remote command. What
  118. # stupid lossage. TODO: think of a reliable workaround.
  119. if [ $? -ne 0 ] ; then
  120. echo "Backup of ${1} failed."
  121. # I'm assuming that the tar will have written an empty
  122. # file to the tape, otherwise I should do a cat here.
  123. else
  124. if [ "z${localhost}" != "z${remotehost}" ] ; then
  125. rsh "${remotehost}" mv -f /etc/tar-backup/temp.level-1 "/etc/tar-backup/${fsname}.level-1"
  126. else
  127. mv -f /etc/tar-backup/temp.level-1 "/etc/tar-backup/${fsname}.level-1"
  128. fi
  129. fi
  130. ${TAPE_STATUS}
  131. sleep 60
  132. shift
  133. done
  134. # Dump any individual files requested.
  135. if [ "x${BACKUP_FILES}" != "x" ] ; then
  136. date="`date`"
  137. TAR_PART2="--listed=/etc/tar-backup/temp.level-1"
  138. TAR_PART3="--label='Incremental backup of miscellaneous files at ${date}'"
  139. echo "Backing up miscellaneous files at ${date}"
  140. echo "Last full dump of these files:"
  141. ls -l /etc/tar-backup/misc.level-0
  142. rm -f /etc/tar-backup/temp.level-1
  143. cp /etc/tar-backup/misc.level-0 /etc/tar-backup/temp.level-1
  144. # Using `sh -c exec' causes nested quoting and shell substitution
  145. # to be handled here in the same way rsh handles it.
  146. sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3} ${BACKUP_FILES}"
  147. if [ $? -ne 0 ] ; then
  148. echo "Backup of miscellaneous files failed." 1>&2
  149. # I'm assuming that the tar will have written an empty
  150. # file to the tape, otherwise I should do a cat here.
  151. else
  152. mv -f /etc/tar-backup/temp.level-1 /etc/tar-backup/misc.level-1
  153. fi
  154. ${TAPE_STATUS}
  155. else
  156. echo "No miscellaneous files specified"
  157. fi
  158. # Caveat: some versions of `mt' use `-t' instead of `-f'.
  159. mt -f "${TAPE_FILE}" rewind
  160. mt -f "${TAPE_FILE}" offl
  161. ) 2>&1 | tee -a "${LOGFILE}"
  162. echo "Sending the dump log to ${ADMINISTRATOR}"
  163. mail -s "Results of backup started ${startdate}" ${ADMINISTRATOR} < "${LOGFILE}"
  164. # eof